'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.exec = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var exec = exports.exec = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(argv2) {
    var argv, loglevel, input, inputJson, inputBin, bin, inputFin, config, configJson, output, autoOutput, name, ext, targets, _iteratorNormalCompletion3, _didIteratorError3, _iteratorError3, _iterator3, _step3, _target2, f, target, file, _iteratorNormalCompletion4, _didIteratorError4, _iteratorError4, _iterator4, _step4, _target, _file, tuple, records, stripes, _iteratorNormalCompletion5, _didIteratorError5, _iteratorError5, _iterator5, _step5, _target3, slash, _iteratorNormalCompletion6, _didIteratorError6, _iteratorError6, _iterator6, _step6, _target4, buffer;

    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            // eslint-disable-line complexity

            argv = (0, _minimist2.default)(argv2, {
              string: ['_', 'c', 'config', 'l', 'loglevel', 'o', 'output', 't', 'target', 'targets']
            });

            // loglevel

            loglevel = argv.l || argv.loglevel;

            if (!loglevel) {
              _context.next = 6;
              break;
            }

            if (_reporter2.default.isCorrectLevel(loglevel)) {
              _context.next = 5;
              break;
            }

            throw new Error('Incorrect loglevel: ' + loglevel);

          case 5:
            _reporter2.default.level = loglevel;

          case 6:
            if (!(argv._.length > 1)) {
              _context.next = 8;
              break;
            }

            throw new Error('Not more than one input file/directory is expected');

          case 8:
            if (argv._.length) {
              _context.next = 10;
              break;
            }

            throw new Error('At least one input file/directory is expected');

          case 10:

            // input

            input = _path2.default.resolve(argv._[0]);
            _context.next = 13;
            return (0, _fsPromise.exists)(input);

          case 13:
            if (_context.sent) {
              _context.next = 15;
              break;
            }

            throw new Error('Input ' + input + ' does not exist');

          case 15:
            _context.next = 17;
            return (0, _fsPromise.stat)(input);

          case 17:
            if (!_context.sent.isDirectory()) {
              _context.next = 23;
              break;
            }

            input = _path2.default.join(input, 'package.json');
            _context.next = 21;
            return (0, _fsPromise.exists)(input);

          case 21:
            if (_context.sent) {
              _context.next = 23;
              break;
            }

            throw new Error('Input ' + input + ' does not exist');

          case 23:

            // inputJson

            inputJson = null;

            if (!(0, _common.isPackageJson)(input)) {
              _context.next = 30;
              break;
            }

            _context.t0 = JSON;
            _context.next = 28;
            return (0, _fsPromise.readFile)(input);

          case 28:
            _context.t1 = _context.sent;
            inputJson = _context.t0.parse.call(_context.t0, _context.t1);

          case 30:

            // inputBin

            inputBin = null;

            if (!inputJson) {
              _context.next = 40;
              break;
            }

            bin = inputJson.bin;

            if (!bin) {
              _context.next = 40;
              break;
            }

            if ((typeof bin === 'undefined' ? 'undefined' : (0, _typeof3.default)(bin)) === 'object') {
              if (bin[inputJson.name]) {
                bin = bin[inputJson.name];
              } else {
                bin = bin[(0, _keys2.default)(bin)[0]]; // TODO multiple inputs to compile them all?
              }
            }
            inputBin = _path2.default.resolve(_path2.default.dirname(input), bin);
            _context.next = 38;
            return (0, _fsPromise.exists)(inputBin);

          case 38:
            if (_context.sent) {
              _context.next = 40;
              break;
            }

            throw new Error('Package.json bin entry ' + inputBin + ' does not exist');

          case 40:

            // inputFin

            inputFin = inputBin || input;

            // config

            config = argv.c || argv.config;

            if (!(inputJson && config)) {
              _context.next = 44;
              break;
            }

            throw new Error('Specify either \'package.json\' or config. Not both');

          case 44:

            // configJson

            configJson = null;

            if (!config) {
              _context.next = 53;
              break;
            }

            config = _path2.default.resolve(config);
            _context.next = 49;
            return (0, _fsPromise.exists)(config);

          case 49:
            if (_context.sent) {
              _context.next = 51;
              break;
            }

            throw new Error('Config file ' + config + ' does not exist');

          case 51:
            configJson = require(config); // may be either json or js
            if (!configJson.name && !configJson.files && !configJson.dependencies) {
              // package.json not detected
              configJson = { pkgConfig: configJson };
            }

          case 53:

            // output

            output = argv.o || argv.output;
            autoOutput = false;


            if (!output) {
              name = inputJson ? inputJson.name : _path2.default.basename(inputFin);
              ext = _path2.default.extname(name);

              output = name.slice(0, -ext.length || undefined);
              output = _path2.default.join(_path2.default.dirname(input), name);
              autoOutput = true;
            }

            // targets

            targets = parse(argv.t || argv.target || argv.targets);


            if (!targets.length) {
              if (!autoOutput) {
                targets = parse('-');
                (0, _assert2.default)(targets.length === 1);
              } else {
                targets = parse('linux,osx,win');
              }
              _log.log.warn('Targets not specified. ' + ('Assuming ' + targets.map(humanize).join(', ')));
            }

            _iteratorNormalCompletion3 = true;
            _didIteratorError3 = false;
            _iteratorError3 = undefined;
            _context.prev = 61;
            _iterator3 = (0, _getIterator3.default)(targets);

          case 63:
            if (_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done) {
              _context.next = 78;
              break;
            }

            _target2 = _step3.value;
            _context.next = 67;
            return (0, _pkgFetch.need)(_target2);

          case 67:
            _target2.binaryPath = _context.sent;
            f = _target2.fabricator = fabricatorForTarget(_target2);
            _context.next = 71;
            return (0, _pkgFetch.need)(f);

          case 71:
            f.binaryPath = _context.sent;

            if (!(f.platform !== 'win')) {
              _context.next = 75;
              break;
            }

            _context.next = 75;
            return (0, _chmod.plusx)(f.binaryPath);

          case 75:
            _iteratorNormalCompletion3 = true;
            _context.next = 63;
            break;

          case 78:
            _context.next = 84;
            break;

          case 80:
            _context.prev = 80;
            _context.t2 = _context['catch'](61);
            _didIteratorError3 = true;
            _iteratorError3 = _context.t2;

          case 84:
            _context.prev = 84;
            _context.prev = 85;

            if (!_iteratorNormalCompletion3 && _iterator3.return) {
              _iterator3.return();
            }

          case 87:
            _context.prev = 87;

            if (!_didIteratorError3) {
              _context.next = 90;
              break;
            }

            throw _iteratorError3;

          case 90:
            return _context.finish(87);

          case 91:
            return _context.finish(84);

          case 92:
            if (!(targets.length === 1)) {
              _context.next = 99;
              break;
            }

            target = targets[0];
            file = output;

            if (target.platform === 'win' && autoOutput) file += '.exe';
            target.output = file;
            _context.next = 118;
            break;

          case 99:
            _iteratorNormalCompletion4 = true;
            _didIteratorError4 = false;
            _iteratorError4 = undefined;
            _context.prev = 102;

            for (_iterator4 = (0, _getIterator3.default)(targets); !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
              _target = _step4.value;
              _file = output + '-' + humanize(_target);

              if (_target.platform === 'win') _file += '.exe';
              _target.output = _file;
            }
            _context.next = 110;
            break;

          case 106:
            _context.prev = 106;
            _context.t3 = _context['catch'](102);
            _didIteratorError4 = true;
            _iteratorError4 = _context.t3;

          case 110:
            _context.prev = 110;
            _context.prev = 111;

            if (!_iteratorNormalCompletion4 && _iterator4.return) {
              _iterator4.return();
            }

          case 113:
            _context.prev = 113;

            if (!_didIteratorError4) {
              _context.next = 116;
              break;
            }

            throw _iteratorError4;

          case 116:
            return _context.finish(113);

          case 117:
            return _context.finish(110);

          case 118:

            // tuple

            tuple = void 0;


            if (configJson) {
              tuple = {
                config: configJson,
                base: _path2.default.dirname(config)
              };
            } else {
              tuple = {
                config: inputJson || {},
                base: _path2.default.dirname(input) // not `inputBin` because only `input`
              }; // is the place for `inputJson`
            }

            // records

            _context.next = 122;
            return (0, _walker2.default)({
              tuple: tuple, input: inputFin
            });

          case 122:
            records = _context.sent;


            // TODO memory consuming! when streams?
            stripes = {};
            _iteratorNormalCompletion5 = true;
            _didIteratorError5 = false;
            _iteratorError5 = undefined;
            _context.prev = 127;
            _iterator5 = (0, _getIterator3.default)(targets);

          case 129:
            if (_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done) {
              _context.next = 140;
              break;
            }

            _target3 = _step5.value;
            slash = _target3.platform === 'win' ? '\\' : '/';

            _target3.slash = slash;

            if (stripes[slash]) {
              _context.next = 137;
              break;
            }

            _context.next = 136;
            return (0, _packer2.default)({ records: records, slash: slash });

          case 136:
            stripes[slash] = _context.sent;

          case 137:
            _iteratorNormalCompletion5 = true;
            _context.next = 129;
            break;

          case 140:
            _context.next = 146;
            break;

          case 142:
            _context.prev = 142;
            _context.t4 = _context['catch'](127);
            _didIteratorError5 = true;
            _iteratorError5 = _context.t4;

          case 146:
            _context.prev = 146;
            _context.prev = 147;

            if (!_iteratorNormalCompletion5 && _iterator5.return) {
              _iterator5.return();
            }

          case 149:
            _context.prev = 149;

            if (!_didIteratorError5) {
              _context.next = 152;
              break;
            }

            throw _iteratorError5;

          case 152:
            return _context.finish(149);

          case 153:
            return _context.finish(146);

          case 154:
            _iteratorNormalCompletion6 = true;
            _didIteratorError6 = false;
            _iteratorError6 = undefined;
            _context.prev = 157;
            _iterator6 = (0, _getIterator3.default)(targets);

          case 159:
            if (_iteratorNormalCompletion6 = (_step6 = _iterator6.next()).done) {
              _context.next = 172;
              break;
            }

            _target4 = _step6.value;
            _context.next = 163;
            return (0, _producer2.default)({
              stripe: stripes[_target4.slash],
              fabricatorName: _target4.fabricator.binaryPath,
              houseName: _target4.binaryPath
            });

          case 163:
            buffer = _context.sent;
            _context.next = 166;
            return (0, _fsPromise.writeFile)(_target4.output, buffer);

          case 166:
            if (!(_target4.platform !== 'win')) {
              _context.next = 169;
              break;
            }

            _context.next = 169;
            return (0, _chmod.plusx)(_target4.output);

          case 169:
            _iteratorNormalCompletion6 = true;
            _context.next = 159;
            break;

          case 172:
            _context.next = 178;
            break;

          case 174:
            _context.prev = 174;
            _context.t5 = _context['catch'](157);
            _didIteratorError6 = true;
            _iteratorError6 = _context.t5;

          case 178:
            _context.prev = 178;
            _context.prev = 179;

            if (!_iteratorNormalCompletion6 && _iterator6.return) {
              _iterator6.return();
            }

          case 181:
            _context.prev = 181;

            if (!_didIteratorError6) {
              _context.next = 184;
              break;
            }

            throw _iteratorError6;

          case 184:
            return _context.finish(181);

          case 185:
            return _context.finish(178);

          case 186:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this, [[61, 80, 84, 92], [85,, 87, 91], [102, 106, 110, 118], [111,, 113, 117], [127, 142, 146, 154], [147,, 149, 153], [157, 174, 178, 186], [179,, 181, 185]]);
  }));

  return function exec(_x) {
    return _ref.apply(this, arguments);
  };
}();

var _fsPromise = require('fs-promise');

var _pkgFetch = require('pkg-fetch');

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _common = require('../runtime/common.js');

var _log = require('./log.js');

var _minimist = require('minimist');

var _minimist2 = _interopRequireDefault(_minimist);

var _packer = require('./packer.js');

var _packer2 = _interopRequireDefault(_packer);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _chmod = require('./chmod.js');

var _producer = require('./producer.js');

var _producer2 = _interopRequireDefault(_producer);

var _reporter = require('./reporter.js');

var _reporter2 = _interopRequireDefault(_reporter);

var _walker = require('./walker.js');

var _walker2 = _interopRequireDefault(_walker);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var hostArch = _pkgFetch.system.hostArch;
var hostPlatform = _pkgFetch.system.hostPlatform;
var knownArchs = _pkgFetch.system.knownArchs;
var knownPlatforms = _pkgFetch.system.knownPlatforms;
var toFancyArch = _pkgFetch.system.toFancyArch;
var toFancyPlatform = _pkgFetch.system.toFancyPlatform;

var hostNodeRange = 'v' + process.version[1];

function parse(items) {
  // v6-osx-x64,v6-linux-x64
  if (!items) return [];
  var targets = [];
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = (0, _getIterator3.default)(items.split(',')), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var item = _step.value;

      var target = {
        nodeRange: hostNodeRange,
        platform: hostPlatform,
        arch: hostArch
      };
      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        for (var _iterator2 = (0, _getIterator3.default)(item.split('-')), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var token = _step2.value;

          if (!token) continue;
          var p = toFancyPlatform(token);
          if (knownPlatforms.indexOf(p) >= 0) {
            target.platform = p;
            continue;
          }
          var a = toFancyArch(token);
          if (knownArchs.indexOf(a) >= 0) {
            target.arch = a;
            continue;
          }
          target.nodeRange = token;
        }
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2.return) {
            _iterator2.return();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }

      targets.push(target);
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return targets;
}

function humanize(target) {
  var nodeRange = target.nodeRange;
  var platform = target.platform;
  var arch = target.arch;

  return nodeRange + '-' + platform + '-' + arch;
}

function fabricatorForTarget(target) {
  var nodeRange = target.nodeRange;

  return { nodeRange: nodeRange, platform: hostPlatform, arch: hostArch };
}